﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace MemoryPatch
{
    public partial class SelectProcess : Form
    {        
        private Dictionary<int, Process> _processes = 
            new Dictionary<int,Process>();
        private Dictionary<int, ProcessModule> _modules = 
            new Dictionary<int, ProcessModule>();
        private Process _process;

        public ProcessEventArgs Args { get; private set; }
        public SelectProcess()
        {
            InitializeComponent();
        }

        private void SelectProcess_Load(object sender, EventArgs e)
        {
            lstProcess.Items.Clear();
            lstModules.Items.Clear();
            _processes.Clear();
            _modules.Clear();
            _process = null;
            Args = null;
            Process[] processes = Process.GetProcesses();

            foreach (Process process in processes)
            {
                _processes.Add(lstProcess.Items.Count, process);
                lstProcess.Items.Add(process.ProcessName);
            }
        }

        private void lstProcess_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i = lstProcess.SelectedIndex;
            if (i > -1)
            {
                try
                {
                    _process = _processes[i];
                    lstModules.Items.Clear();
                    _modules.Clear();
                    for (int x = 0; x < _process.Modules.Count; x++)
                    {
                        _modules.Add(lstModules.Items.Count, _process.Modules[x]);
                        lstModules.Items.Add(_process.Modules[x].ModuleName);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error " + ex.Message);
                }
            }
        }
       
        private void btnOK_Click(object sender, EventArgs e)
        {
            int i = lstModules.SelectedIndex;
            if (i > -1 && _process != null)
            {
                Args = new ProcessEventArgs(_process, _modules[i]);
                this.Hide();
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Hide();
        }
    }

    public class ProcessEventArgs: EventArgs
    {
        public Process Process {get; private set;}
        public ProcessModule Module { get; private set; }

        public ProcessEventArgs(Process process, ProcessModule module)
        {
            Process = process;
            Module = module;
        }
    }
}
